<?php

namespace OpenXdmod\Migration\Version751To800;

use OpenXdmod\Migration\ConfigFilesMigration as AbstractConfigFilesMigration;

/**
 * Update config files from version 7.5.1 to 8.0.0.
 */
class ConfigFilesMigration extends AbstractConfigFilesMigration
{
    /**
     * Execute the migration.
     */
    public function execute()
    {
        // Make sure all the config files that will be changed are writable.
        $this->assertPortalSettingsIsWritable();

        // Set new options in portal_settings.ini.
        $this->writePortalSettingsFile(array(
            'general_application_secret' => bin2hex(\random_bytes(256)),
            "general_email_token_expiration" => "600"
        ));
    }
}
