---
title: Terminology
---

There are several terms that may be ambiguous when used out of context.
These are listed below with the typical meaning in Open XDMoD.

### Account

Typically a resource manager account, not necessarily a user account.

### Cluster

The words resource and cluster may be used interchangeably.

### Core

A single cpu core in a node.

The words CPU, core and processor may be used interchangeably.

### CPU

A single cpu core in a node.

The words CPU, core and processor may be used interchangeably.

### Group

Unix group name or gid. Typically the primary group of a user that
submitted a job.

### Host

A single resource node.

The words host and node may be used interchangeably.

### Ingestion/Ingestor

Refers to the process of importing data into the datawarehouse,
typically from another database.

### Node

A single resource node.

The words host and node may be used interchangeably.

### Partition

Used by slurm, called queue by Open XDMoD.

### Processor

A single cpu core in a node.

The words CPU, core and processor may be used interchangeably.

### PI

A principal investigator.  Typically determined by the Unix group or
resource manager account used by a job.

### Queue

The queue a job has been submitted to.

### User

Unix user name or uid.  The unix user that submitted a job.

### Resource

An HPC resource.

The words resource and cluster may be used interchangeably.

### Shredding/Shredder

Shredding is the process of parsing and importing data from log files.


TODO

Explain shredding and ingestion.

Explain host, cluster, resource.

Explain groups and P.I. relationship.

Explain processors, cpus, cores.
